;; $Id: append!.scm,v 1.2 1999/08/11 16:27:56 leavens Exp $
;; AUTHOR: Gary T. Leavens

(define append!
  ;TYPE: (-> ((list T) (list T)) (list T))
  (lambda (ls1 ls2)
    ; MODIFIES: ls1
    ; EFFECT: modify ls1 to have the
    ; elements of ls1 followed by ls2's
    (if (null? ls1)
	ls2
        (begin
          (set-cdr! (last-pair ls1) ls2)
          ls1))))

(define last-pair
  ; TYPE: (-> ((nonempty-list T))
  ;           (pair T (list T)))
  (lambda (x)
    (if (null? (cdr x))
        x
        (last-pair (cdr x)))))
