;;; $Id: ch5-1-4-expressed-value.scm,v 1.3 1998/10/26 21:34:05 leavens Exp $

(load-quietly-from-lib "inject-extract.scm")

(define number->expressed
  ;; TYPE: (-> (number) Expressed-Value)
  inject)

(define procedure->expressed
  ;; TYPE: (-> (Procedure) Expressed-Value)
  inject)

(define list->expressed
  ;; TYPE: (-> ((list Expressed-Value)) Expressed-Value)
  inject)

(define ch5-1-4-expressed-value:extract
  ;; TYPE: (-> ((-> (Expressed-Value) boolean) string) (-> (T) T))
  (extract-maker "expressed"))

(define expressed->number
  ;; TYPE: (-> (Expressed-Value) number)
  (ch5-1-4-expressed-value:extract number? "number"))

(define expressed->procedure
  ;; TYPE: (-> (Expressed-Value) Procedure)
  (ch5-1-4-expressed-value:extract prim-proc? "procedure"))

(define expressed->list
  ;; TYPE: (-> (Expressed-Value) (list Expressed-Value))
  (ch5-1-4-expressed-value:extract (lambda (x) (or (pair? x) (null? x)))
				   "list"))

(define denoted->expressed
  ;; TYPE: (-> (Denoted-Value) Expressed-Value)
  (lambda (dv) dv))

(define expressed->denoted
  ;; TYPE: (-> (Expressed-Value) Denoted-Value)
  (lambda (ev) ev))
