;; $Id: ch6-1-3.scm,v 1.8 1998/11/12 22:53:20 leavens Exp $

;; Code from the EOPL chapter 6 revision, figure 6.1.3
;; (arrays in the indirect model, call-by-value).

;;; Grammar:
;;          see the file ch6-base.scm for details

(load-from-lib "ch6-base.scm")

;;; Domains for this interpreter:
;;;
;;; Environment = <var> -> Denoted-Value
;;; Denoted-Value = Cell(Expressed-Value)
;;; Expressed-Value = Number + Procedure + Array(Expressed-Value)
;;;                   + List(Expressed-Value) + Void
;;; Procedure = prim-proc + closure
;;; Array(T) = {Cell(T)}*

(load-quietly-from-lib "ch6-1-3-denoted-value.scm")
(load-quietly-from-lib "ch6-1-3-expressed-value.scm")


;;; Figure 6.1.3 : page 183

(define denoted->expressed
  ;; TYPE: (-> (Denoted-Value) Expressed-Value)
  cell-ref)

(define expressed->denoted
  ;; TYPE: (-> (Expressed-Value) Denoted-Value)
  make-cell)

(define denoted-value-assign!
  ;; TYPE: (-> (Denoted-Value Expressed-Value) void)
  cell-set!)

(define do-letarray
  ;; TYPE: (-> (number) Denoted-Value)
  (lambda (n)
    (if (not (<= 0 n))  ; added error check vs. text
	(error "do-letarray: bad index")
	(make-cell (array->expressed (make-array n))))))

(define eval-array-exp
  ;; TYPE: (-> (parsed-exp Environment) Expressed-Value)
  (lambda (exp env)
    (eval-exp exp env)))

;; addition to figure 6.1.3

(define array-element-assign!
  ;; TYPE: (-> ((Array Expressed-Value) number Expressed-Value) void)
  array-set!)
