;;; $Id: ch6-5-2.tst,v 1.1 1998/12/02 16:22:40 leavens Exp $

(load-quietly-from-lib "run.scm")

(run-regression-tests-equal?
 `(
    ( (run "let p = proc (b) b[0] := 3
            in letarray a[2] in begin a[0] := 1; a[1] := 2; p(a); a[0] end")
       ==> 3 )
    ( (run
"letarray u[3]; v[2]
in begin
     u[0] := 5; u[1] := 6; u[2] := 4; v[0] := 3; v[1] := 8;
     let p = proc (x)
               begin
                 x[1] := 7;
                 x := v;
                 x[1] := 9
               end
     in begin
          p(u);
          list(u[0], u[1], v[0], v[1])
        end
   end")
    ==> (3 9 3 9) )
    ( (run
"let p = proc (x) x := 5
in let a = 3; 
       b = 4
   in begin
        p(a);
        p(b);
        +(a, b)
      end")
    ==> 7 )
    ( (run
"let p = proc (x) x := 5
in local a = 3; 
         b = 4
   in begin
        p(a);
        p(b);
        +(a, b)
      end")
    ==> 10 )
    ( (run
"local swap =
      proc (x, y)
        local temp = 0 
        in begin temp := x; x := y; y := temp end;
       c = 3;
       b = 4 
    in begin
         swap(c, b);
         list(b, c)
       end")
     ==> (3 4) )
   ( (run "
local c = 3; 
      p = proc (x) x := 5
in begin 
      p(add1(c));
      c
    end")
     ==> 3 )
   ( (run "
local c = 3; 
      p = proc (x) x := 5;
      two = proc(y) 2
in local z = two(p(c))
   in list(z, c)")
     ==> (2 3) )
   ( (run "
local c = 3;
      two = proc(y) 2
in letrec ohno = proc () ohno()
   in
     local z = two(ohno())
     in list(z, c)")
     ==> (2 3) )
   ( (run "
local c = 0; 
      p = proc (x) begin x := +(x, 5); x end
in let a = p(c)
   in list(a, a, c)")
     ==> (5 10 10) )
   )
 )
