;;; $Id: cond-clause.scm,v 1.1 1998/10/05 07:52:21 leavens Exp $
;;; Cond clauses
;;; Grammar:
;;;   <(cond-clause T)> ::= (<T> <T>)

(define cond-clause?
  ;; TYPE: (-> (datum) boolean)
  (lambda (x)
    (and (list? x)
	 (= (length x) 2))))

(define make-cond-clause
  ;; TYPE: (-> (T T) (cond-clause T))
  list)

(define cond-clause->test
  ;; TYPE: (-> ((cond-clause T)) T)
  car)

(define cond-clause->body
  ;; TYPE: (-> ((cond-clause T)) T)
  cadr)

(define parse-cond-clause-maker
  ;; TYPE: (-> ((-> (datum) T)) (-> (datum) (cond-clause T)))
  (lambda (parse-exp)
    (lambda (exp)
      (cond
       ((cond-clause? exp)
	(make-cond-clause (parse-exp (car exp)) (parse-exp (cadr exp))))
       (else (error "parse-cond-clause: bad syntax in: " exp))))))
