;; call/cc -- an abbreviation
(define call/cc call-with-current-continuation)

;; writeln -- a debugging utility
(define writeln
  (lambda args
    (for-each display args)
    (newline)))


;; new-escaper -- alternate def of escaper
(define new-escaper "any-procedure")

(let ((receiver (lambda (continuation)
		  (set! new-escaper
			(lambda (proc)
			  (lambda args
			    (continuation
			     (lambda ()
			       (apply proc args))))))
		  (lambda () writeln "new-escaper is defined"))))
  ((call/cc receiver)))

(define abort-operational
  (new-escaper (lambda (x) x)))

(define abort-defined
  (lambda (e)
    (call/cc (lambda (d) e))))

(define *abort* "any continuation")

((call/cc (lambda (k) (set! *abort* k))))


(define-macro (A e)
  (list '*abort* `(lambda () ,@e)))


;; Felleisen's C operator, which should be a macro, not a function as below...
(define (C e)
  (call/cc (lambda (k) (abort (e k)))))

; note that call/cc = (lambda (f) (C (lambda (k)  (k (f k)))))


;; escaper -- see Springer and Friedman 89
(define *escape/thunk* "any continuation")

(define escaper
  (lambda (proc)
    (lambda args
      (*escape/thunk*
       (lambda ()
	 (apply proc args))))))

(define receiver-4
  (lambda (continuation)
    (set! *escape/thunk* continuation)
    (*escape/thunk* (lambda () (writeln ";escaper is defined")))))

((call/cc receiver-4))

