;; @(#)$Id: grav-force.scm,v 1.2 1999/08/11 16:28:07 leavens Exp $

;;; Name:  Gary T. Leavens
;;; Section:  all

;	GRAVITATIONAL FORCE EXAMPLE
	
(define G
  ; TYPE: N * m^2 / kg^2
  6.670e-11)

(define square
  ; TYPE: (-> (m) m^2)
  (lambda (r) (* r r)))

(define grav-force
  ; TYPE: (-> (kg m kg) N)
  (lambda (m1 r m2)	
    (if (zero? r) 
	0.0
	(/ (* G (* m1 m2))
	   (square r)))))

(define grav-force-c 
  ; TYPE: (-> (kg)
  ;           (-> (m)
  ;               (-> (kg)
  ;                   N)))
  (lambda (m1)			; kg 
    (lambda (r)			; m
      (lambda (m2)		; kg 
          (if (zero? r) 
	      0.0
              (/ (* G (* m1 m2))
	         (square r)))))))

      
;		USING IT

(define mass-of-earth
  ; TYPE: kg
  5.96e24)

(define radius-of-earth
  ; TYPE: m
  6.37e6)

(define earths-force
   ; TYPE: (-> (m) (-> (kg) N))
   (grav-force-c mass-of-earth))

(define force-at-surface
   ; TYPE: (-> (kg) N)
   (earths-force radius-of-earth))
