;; $Id: lambda-1+quote-examples.tst,v 1.2 1998/09/29 01:37:30 leavens Exp $

(run-regression-tests-equal?
 `(
    ( (count-varrefs (make-varref 'x)) ==> 1 )
    ( (count-varrefs (make-quote 'z)) ==> 0 )
    ( (count-varrefs (make-app (make-varref 'x) (make-varref 'y))) ==> 2 )
    ( (count-varrefs (parse-lambda-1+quote '(x y))) ==> 2 )
    ( (count-varrefs (parse-lambda-1+quote '(lambda (x) x))) ==> 1 )
    ( (count-varrefs (parse-lambda-1+quote '((lambda (x) x) (quote z))))
      ==> 1 )
    ( (count-varrefs (parse-lambda-1+quote '((lambda (x) x) 'z))) ==> 1 )
    ( (count-varrefs (parse-lambda-1+quote '(f (lambda (x) x)))) ==> 2 )

    ( (all-varrefs (parse-lambda-1+quote 'x)) ==> (x) )
    ( (all-varrefs (parse-lambda-1+quote '(quote z))) ==> () )
    ( (all-varrefs (parse-lambda-1+quote '(x y))) ==> (x y) )
    ( (all-varrefs (parse-lambda-1+quote '(lambda (x) y))) ==> (y) )
    ( (all-varrefs (parse-lambda-1+quote '((lambda (x) x) (quote z))))
      ==> (x) )
    ( (all-varrefs (parse-lambda-1+quote '(f (lambda (x) (x (f x))))))
      ==> (f x f x) )

    ( (subst-varrefs 'new 'old (parse-lambda-1+quote 'old))
      ==> new )
    ( (subst-varrefs 'n 'o (parse-lambda-1+quote '(quote z)))
      ==> (quote z) )
    ( (subst-varrefs 'y 'x (parse-lambda-1+quote '(x y)))
      ==> (y y) )
    ( (subst-varrefs 'y 'x (parse-lambda-1+quote '(lambda (x) y)))
      ==> (lambda (x) y) )
    ( (subst-varrefs 'y 'x (parse-lambda-1+quote '((lambda (x) x) (quote z))))
      ==> ((lambda (x) y) (quote z)) )
    ( (subst-varrefs 'y 'x (parse-lambda-1+quote '(f (lambda (x) (x (f x))))))
      ==> (f (lambda (x) (y (f y)))) )
    )
 )

