;; $Id: lambda-multiple+if-examples.tst,v 1.1 1998/09/29 01:33:38 leavens Exp $

(run-regression-tests-equal?
 `(
    ( (count-varrefs (make-varref 'x)) ==> 1 )
    ( (count-varrefs (make-quote 'z)) ==> 0 )
    ( (count-varrefs (make-if (make-varref 'b)
			      (make-varref 'c)
			      (make-varref 'a))) ==> 3 )
    ( (count-varrefs (make-app (make-varref 'x) (list (make-varref 'y)))) ==> 2 )
    ( (count-varrefs (parse-lcm+if-exp '(if b c a))) ==> 3 )
    ( (count-varrefs (parse-lcm+if-exp '(x y))) ==> 2 )
    ( (count-varrefs (parse-lcm+if-exp '(lambda (x) x))) ==> 1 )
    ( (count-varrefs (parse-lcm+if-exp '((lambda (x) x) (quote z))))
      ==> 1 )
    ( (count-varrefs (parse-lcm+if-exp '((lambda (x) x) 'z))) ==> 1 )
    ( (count-varrefs (parse-lcm+if-exp '(f (lambda (x) x)))) ==> 2 )

    ( (all-varrefs (parse-lcm+if-exp 'x)) ==> (x) )
    ( (all-varrefs (parse-lcm+if-exp '(quote z))) ==> () )
    ( (all-varrefs (parse-lcm+if-exp '(if b c a))) ==> (b c a) )
    ( (all-varrefs (parse-lcm+if-exp '(x y))) ==> (x y) )
    ( (all-varrefs (parse-lcm+if-exp '(lambda (x) y))) ==> (y) )
    ( (all-varrefs (parse-lcm+if-exp
		    '(if b (lambda (z) c) (lambda () (f x y)))))
      ==> (b c f x y) )
    ( (all-varrefs (parse-lcm+if-exp '((lambda (x) x) (quote z))))
      ==> (x) )
    ( (all-varrefs (parse-lcm+if-exp '(f (lambda (x) (x (f x))))))
      ==> (f x f x) )

    ( (subst-varrefs 'new 'old (parse-lcm+if-exp 'old))
      ==> new )
    ( (subst-varrefs 'n 'o (parse-lcm+if-exp '(quote z)))
      ==> (quote z) )
    ( (subst-varrefs 'y 'x (parse-lcm+if-exp '(x y)))
      ==> (y y) )
    ( (subst-varrefs 'y 'x (parse-lcm+if-exp '(lambda (x) y)))
      ==> (lambda (x) y) )
    ( (subst-varrefs 'y 'x (parse-lcm+if-exp '((lambda (x) x) (quote z))))
      ==> ((lambda (x) y) (quote z)) )
    ( (subst-varrefs 'y 'x (parse-lcm+if-exp '(f (lambda (x) (x (f x))))))
      ==> (f (lambda (x) (y (f y)))) )
    ( (subst-varrefs 'y 'x
		     (parse-lcm+if-exp
		      '(if b (lambda (x) c) (lambda () (f x y)))))
      ==> (if b (lambda (x) c) (lambda () (f y y))) )
    )
 )
