;; @(#)$Id: test-homework.scm,v 1.13 1999/08/11 16:10:36 leavens Exp $

(load-quietly-from-lib "writeln.scm")

;;; Uncomment the following if you use SLIB
;;; and if your scheme doesn't have pretty-print built in.
;;; (require 'pretty-print)

(define cs342:test-maker
  ;; change the path in the following to suit your installation!
  (let ((testdir "/home/bambam/leavens/ComS342-EOPL/old-homework/Spring99/"))
    (lambda (n)
      (let ((hw-number (number->string n)))
	(lambda (procedure-name)
	  (if (not (string? procedure-name))
	      (error "argument must be a string, like \"subst\""))
	  (let ((file-to-load (string-append testdir
					     "hw"
					     hw-number
					     ".tst/"
					     procedure-name
					     ".tst")))
	    (display "loading ")
	    (display file-to-load)
	    (display "...")
	    (newline)
	    (load file-to-load)))))))

(define test-hw1
  (cs342:test-maker 1))

(define test-hw2
  (cs342:test-maker 2))

(define test-hw3
  (cs342:test-maker 3))

(define test-hw4
  (cs342:test-maker 4))

(define test-hw5
  (cs342:test-maker 5))

(define test-hw6
  (cs342:test-maker 6))

(define test-hw7
  (cs342:test-maker 7))

(define test-hw8
  (cs342:test-maker 8))

(define test-hw9
  (cs342:test-maker 9))

(define test-hw10
  (cs342:test-maker 10))

(define test-hw11
  (cs342:test-maker 11))

(define test-hw12
  (cs342:test-maker 12))

(define cs342:print-test-case-prefix-maker
  ; TYPE: (-> ((-> (datum) void))
  ;           (-> (scheme-exp) void))
  (lambda (writeln)
    ; EFFECT: writes the code
    writeln))

(define cs342:print-test-case-prefix
  ; TYPE: (-> (scheme-exp) void)
  (cs342:print-test-case-prefix-maker writeln))
  
(define run-test-case-maker
  ; TYPE: (-> ((-> (datum) void) (-> (datum) void))
  ;           (-> (scheme-exp) void))
  (lambda (print-code eval-print-result)
    ; REQUIRES: eval-print-result prints a separator and the result,
    ;           with a newline at the end of it all.
    ; EFFECT: prints the code and the result of executing the code.
    (lambda (code)
      (print-code code)
      (eval-print-result code))))

(define cs342:evals-to-symbol '==>)
(define cs342:equals-symbol '=)

(define cs342:before-connective-spaces "        ")

(define cs342:print-connective-maker
  ; TYPE: (-> (symbol) (-> () void))
  (lambda (connective)
    (lambda ()
      (display cs342:before-connective-spaces)
      (display connective)
      (display " "))))

(define cs342:eval-print-maker
  ; TYPE: (-> ((-> (datum) void))
  ;           (-> (scheme-exp) void))
  (let ((print-arrow (cs342:print-connective-maker cs342:evals-to-symbol)))
    (lambda (writeln)
      (lambda (code)
	(print-arrow)
	(writeln (eval code))))))

(define run-test-case
  ; TYPE: (-> (scheme-exp) void)
  (run-test-case-maker
   (cs342:print-test-case-prefix-maker pretty-print)
   (cs342:eval-print-maker pretty-print)))

(define cs342:num-wrong
  ; TYPE: integer
  0)

(define cs342:regression-test-maker-maker
  ; TYPE: (-> ((-> (symbol) (-> () void)))
  ;           (-> ((-> (datum datum) boolean) (-> (scheme-exp) void)
  ;                (-> (datum) void))
  ;               (-> (scheme-exp symbol datum) void)))
  (lambda (print-connective-maker)
    (let ((print-arrow (print-connective-maker cs342:evals-to-symbol))
	  (print-equal-sign (print-connective-maker cs342:equals-symbol)))
      (lambda (okay? print-code print-result)
	; REQUIRES: connective is either cs342:evals-to-symbol
	;                         or cs342:equals-symbol
	(lambda (code connective expected)
	  (print-code code)
	  (let ((result (eval code)))
	    (cond
	     ((eq? connective cs342:evals-to-symbol)
	      (if (okay? result expected)
		  (begin
		    (print-arrow)
		    (print-result result))
		  (begin
		    (set! cs342:num-wrong (+ cs342:num-wrong 1))
		    (print-arrow)
		    (print-result result)
		    (display "  EXPECTED: ")
		    (print-result expected))))
	      ((eq? connective cs342:equals-symbol)
	       (let ((expected-result (eval expected)))
		 (if (okay? result expected-result)
		     (begin
		       (print-equal-sign)
		       (print-code expected))
		     (begin
		       (set! cs342:num-wrong (+ cs342:num-wrong 1))
		       (print-arrow)
		       (print-result result)
		       (display "  EXPECTED: ")
		       (print-result expected-result)
		       (display "        <== ")
		       (print-code expected)))))
		 (else (error "Bad connective in test case : " connective)))
	    ))))))

(define regression-test-maker
  ; TYPE: (-> ((-> (datum datum) boolean) (-> (scheme-exp) void)
  ;            (-> (datum) void))
  ;           (-> (scheme-exp symbol datum) void))
  (cs342:regression-test-maker-maker cs342:print-connective-maker))

;; WARNING: the following has a different interface than the old one...
(define run-regression-test
  ; TYPE: (-> (scheme-exp symbol datum) void)
  (regression-test-maker equal? pretty-print pretty-print))

(define run-regression-tests-maker
  ; TYPE: (-> ((-> (datum datum) boolean) (-> (scheme-exp) void)
  ;            (-> (datum) void))
  ;           (-> (3-list) void))
  (lambda (okay? print-code print-result)
    (let ((regress (regression-test-maker okay? print-code print-result)))
      (lambda (test-table)
	(let ((old-num-wrong cs342:num-wrong))
	  (for-each
	   (lambda (test) (regress (car test) (cadr test) (caddr test)))
	   test-table)
	  (if (not (= old-num-wrong cs342:num-wrong))
	      (displayln "TOTAL UNEXPECTED RESULTS THIS TEST RUN: "
			 (- cs342:num-wrong old-num-wrong))
	      (displayln "All tests passed!")))))))


(define run-regression-tests-equal?
  ; TYPE: (-> (3-list) void)
  (run-regression-tests-maker equal? pretty-print pretty-print))
