;; $Id: updateable-environments.scm,v 1.5 1998/10/27 02:39:32 leavens Exp $

;; The environment abstraction for the EOPL interpreters.
;; This version adds the operation update-env! that is designed to be used
;; in processing top-level (mutually recursive) definitions.

(load-quietly-from-lib "ff-as-record.scm")

;; assumes this has already been done: (load-from-lib "cell.scm")

(define the-empty-env  ; TYPE: Environment
  (make-cell (create-empty-ff)))

(define extend-env
  ; TYPE: (-> ((list symbol) (list Denoted-Value) Environment) Environment)
  (lambda (vars den-vals env)
    (make-cell (extend-ff* vars den-vals (cell-ref env)))))

(define apply-env
  ; TYPE: (-> (Environment symbol) Denoted-Value)
  (lambda (env sym)
    (apply-ff (cell-ref env) sym)))

(define defined-in-env?
  ; TYPE: (-> (Environment symbol) boolean)
  (lambda (env sym)
    (defined-in-ff? (cell-ref env) sym)))

(define update-env!
  ; TYPE: (-> (Environment symbol Denoted-Value) void)
  (lambda (env var den-val)
    (cell-set! env (extend-ff* (list var) (list den-val) (cell-ref env)))))
